@echo off
setlocal

echo "Myth Pinball Firmware Update V2.1"

echo "Attempting to auto locate Myth Pinball Control Board..."

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino NANO Every"') do (
    call :resetCOM "%%~J"
    goto :EOF
)

echo "Could not located Myth Pinball Control Board... Have you connected via USB Data Cable? ... Please disconnect and try again..."
pause

:: end main batch
goto :EOF

:resetCOM <WMIC_output_line>
:: sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
::echo %port%
echo "Located Myth Pinball Control Board on " + %port%

echo "Attempting Board Reset..."
mode %port%: BAUD=1200 parity=N data=8 stop=1 dtr=ON
mode %port%: BAUD=1200 parity=N data=8 stop=1 dtr=OFF

echo "Attempting Firmware Flash..."
avrdude -Cavrdude.conf -v -patmega4809 -cjtag2updi -P%port% -b115200 -e -D -Uflash:w:firmware.hex:i -Ufuse2:w:0x01:m -Ufuse5:w:0xC9:m -Ufuse8:w:0x00:m {upload.extra_files} 

echo "Process Completed."
pause
